/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.21 Revision 1.34
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.21 2006/05/02 15:04:03 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.34 2006/09/20 08:23:41 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org>
7 8
8# vdr-plugin.eclass 9# vdr-plugin.eclass
9# 10#
10# eclass to create ebuilds for vdr plugins 11# eclass to create ebuilds for vdr plugins
11# 12#
36# Installation of an rc-addon file for the plugin 37# Installation of an rc-addon file for the plugin
37# 38#
38# If ${VDR_RCADDON_FILE} is set install this file 39# If ${VDR_RCADDON_FILE} is set install this file
39# else install ${FILESDIR}/rc-addon.sh if it exists. 40# else install ${FILESDIR}/rc-addon.sh if it exists.
40# 41#
41# Gets installed under /usr/lib/vdr/rcscript/plugin-${VDRPLUGIN}.sh 42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
42# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh) 43# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh)
43# 44#
44# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr 45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
45# It could be used for special startup actions for this plugins, or to create the 46# It could be used for special startup actions for this plugins, or to create the
46# plugin command line options from a nicer version of a conf.d file. 47# plugin command line options from a nicer version of a conf.d file.
47 48
49# HowTo use own local patches; Example
50#
51# Add to your /etc/make.conf:
52# VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53#
54# Add two DIR's in your local patch dir, ${PN}/${PV},
55# e.g for vdr-burn-0.1.0 should be:
56# /usr/local/patch/vdr-burn/0.1.0/
57#
58# all patches which ending on diff or patch in this DIR will automatically applied
59#
60
48inherit base eutils flag-o-matic 61inherit base multilib eutils flag-o-matic
49 62
50IUSE="debug" 63IUSE="debug"
51 64
52# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
53VDRPLUGIN="${PN/#vdrplugin-/}" 66VDRPLUGIN="${PN/#vdrplugin-/}"
58 71
59# works in most cases 72# works in most cases
60S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
61 74
62# depend on headers for DVB-driver 75# depend on headers for DVB-driver
63RDEPEND="" 76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1"
64DEPEND="media-tv/linuxtv-dvb-headers" 77DEPEND="media-tv/linuxtv-dvb-headers"
65
66# Where should the plugins live in the filesystem
67VDR_PLUGIN_DIR="/usr/lib/vdr/plugins"
68
69VDR_RC_DIR="/usr/lib/vdr/rcscript"
70
71# Pathes to includes
72VDR_INCLUDE_DIR="/usr/include"
73DVB_INCLUDE_DIR="/usr/include"
74 78
75 79
76# this code is from linux-mod.eclass 80# this code is from linux-mod.eclass
77update_vdrplugindb() { 81update_vdrplugindb() {
78 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
99vdr-plugin_pkg_setup() { 103vdr-plugin_pkg_setup() {
100 # -fPIC is needed for shared objects on some platforms (amd64 and others) 104 # -fPIC is needed for shared objects on some platforms (amd64 and others)
101 append-flags -fPIC 105 append-flags -fPIC
102 use debug && append-flags -g 106 use debug && append-flags -g
103 107
108 # Where should the plugins live in the filesystem
109 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
110 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
111
112 # transition to /usr/share/... will need new vdr-scripts version stable
113 VDR_RC_DIR="/usr/lib/vdr/rcscript"
114
115 # Pathes to includes
116 VDR_INCLUDE_DIR="/usr/include/vdr"
117 DVB_INCLUDE_DIR="/usr/include"
118
119
104 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' /usr/include/vdr/config.h) 120 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
105 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' /usr/include/vdr/config.h) 121 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
106 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 122 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
107 123
108 einfo "Building ${PF} against vdr-${VDRVERSION}" 124 einfo "Building ${PF} against vdr-${VDRVERSION}"
109 einfo "APIVERSION: ${APIVERSION}" 125 einfo "APIVERSION: ${APIVERSION}"
110} 126}
111 127
112vdr-plugin_src_unpack() { 128vdr-plugin_src_unpack() {
129 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
130 eerror "Wrong use of vdr-plugin.eclass."
131 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
132 echo
133 eerror "Please report this at bugs.gentoo.org."
134 die "vdr-plugin_pkg_setup not called!"
135 fi
113 [ -z "$1" ] && vdr-plugin_src_unpack unpack patchmakefile 136 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile
114 137
115 while [ "$1" ]; do 138 while [ "$1" ]; do
116 139
117 case "$1" in 140 case "$1" in
141 all_but_unpack)
142 vdr-plugin_src_unpack add_local_patch patchmakefile
143 ;;
118 unpack) 144 unpack)
119 base_src_unpack 145 base_src_unpack
120 ;; 146 ;;
121 patchmakefile) 147 patchmakefile)
122 if ! cd ${S}; then 148 if ! cd ${S}; then
125 cd "${WORKDIR}" 151 cd "${WORKDIR}"
126 einfo "$(/bin/ls -1 ${WORKDIR})" 152 einfo "$(/bin/ls -1 ${WORKDIR})"
127 die "Could not change to plugin-source-directory!" 153 die "Could not change to plugin-source-directory!"
128 fi 154 fi
129 155
130 ebegin "Patching Makefile" 156 einfo "Patching Makefile"
131 [[ -e Makefile ]] || die "Makefile of plugin can not be found!" 157 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
158 cp Makefile Makefile.orig
159
132 sed -i.orig Makefile \ 160 sed -i Makefile \
161 -e '1i\#Makefile was patched by vdr-plugin.eclass'
162
163 ebegin " Setting Pathes"
164 sed -i Makefile \
133 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 165 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
134 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 166 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
135 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \ 167 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
136 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \ 168 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
137 -e 's:^CXXFLAGS:#CXXFLAGS:' \ 169 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
138 -e 's:-I$(VDRDIR)/include:-I$(VDRDIR):' \ 170 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
139 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \ 171 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
140 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' \ 172 eend $?
141 -e 's:$(VDRDIR)/\([a-z]*\.h\|Make.config\):$(VDRDIR)/vdr/\1:' \ 173
174 ebegin " Converting to APIVERSION"
175 sed -i Makefile \
142 -e 's:^APIVERSION = :APIVERSION ?= :' \ 176 -e 's:^APIVERSION = :APIVERSION ?= :' \
143 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \ 177 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
144 -e '1i\APIVERSION = '"${APIVERSION}" 178 -e '2i\APIVERSION = '"${APIVERSION}"
145 eend $? 179 eend $?
180
181 ebegin " Correcting CXXFLAGS"
182 sed -i Makefile \
183 -e 's:^CXXFLAGS:#CXXFLAGS:'
184 eend $?
185
186 ebegin " Disabling file stripping"
187 sed -i Makefile \
188 -e '/@.*strip/d' \
189 -e '/strip \$(LIBDIR)\/\$@/d' \
190 -e '/^STRIP =/d' \
191 -e '/@.*\$(STRIP)/d'
192 eend $?
193
194 # Use a file instead of an variable as single-stepping via ebuild
195 # destroys environment.
196 touch ${WORKDIR}/.vdr-plugin_makefile_patched
197 ;;
198 add_local_patch)
199 cd ${S}
200 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
201 echo
202 einfo "Applying local patches"
203 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
204 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
205 done
206 fi
146 ;; 207 ;;
147 esac 208 esac
148 209
149 shift 210 shift
150 done 211 done
151} 212}
152 213
153vdr-plugin_copy_source_tree() { 214vdr-plugin_copy_source_tree() {
215 pushd . >/dev/null
154 cp -r ${S} ${T}/source-tree 216 cp -r ${S} ${T}/source-tree
155 cd ${T}/source-tree 217 cd ${T}/source-tree
156 mv Makefile.orig Makefile 218 mv Makefile.orig Makefile
157 sed -i Makefile \ 219 sed -i Makefile \
158 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 220 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
159 -e 's:^CXXFLAGS:#CXXFLAGS:' \ 221 -e 's:^CXXFLAGS:#CXXFLAGS:' \
160 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \ 222 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
161 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' 223 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
224 popd >/dev/null
162} 225}
163 226
164vdr-plugin_install_source_tree() { 227vdr-plugin_install_source_tree() {
165 einfo "Installing sources" 228 einfo "Installing sources"
166 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN} 229 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
178 case "$1" in 241 case "$1" in
179 prepare) 242 prepare)
180 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 243 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
181 ;; 244 ;;
182 compile) 245 compile)
246 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
247 eerror "Wrong use of vdr-plugin.eclass."
248 eerror "An ebuild for a vdr-plugin will not work without"
249 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
250 echo
251 eerror "Please report this at bugs.gentoo.org."
252 die "vdr-plugin_src_unpack not called!"
253 fi
183 cd ${S} 254 cd ${S}
184 255
185 emake ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed" 256 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed"
186 ;; 257 ;;
187 esac 258 esac
188 259
189 shift 260 shift
190 done 261 done
192 263
193vdr-plugin_src_install() { 264vdr-plugin_src_install() {
194 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 265 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
195 cd ${S} 266 cd ${S}
196 267
268 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
269 local mname=${P}-Makefile
270 cp Makefile ${mname}.patched
271 cp Makefile.orig ${mname}.before
272
273 diff -u ${mname}.before ${mname}.patched > ${mname}.diff
274
275 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
276 doins ${mname}.diff
277
278 insinto "/usr/share/vdr/maintainer-data/makefile-before"
279 doins ${mname}.before
280
281 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
282 doins ${mname}.patched
283
284 fi
285
197 insinto "${VDR_PLUGIN_DIR}" 286 insinto "${VDR_PLUGIN_DIR}"
198 doins libvdr-*.so.* 287 doins libvdr-*.so.*
288 local docfile
199 dodoc README* HISTORY CHANGELOG 289 for docfile in README* HISTORY CHANGELOG; do
200 290 [[ -f ${docfile} ]] && dodoc ${docfile}
291 done
201 292
202 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it 293 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
203 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd 294 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
204 295
205 if [[ -n ${VDR_CONFD_FILE} ]]; then 296 if [[ -n ${VDR_CONFD_FILE} ]]; then
216 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 307 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
217 fi 308 fi
218 309
219 310
220 311
221 insinto /usr/lib/vdr/checksums 312 insinto ${VDR_CHECKSUM_DIR}
222 if [[ -f ${ROOT}/usr/lib/vdr/checksums/header-md5-vdr ]]; then 313 if [[ -f ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
223 newins ${ROOT}/usr/lib/vdr/checksums/header-md5-vdr header-md5-${PN} 314 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}
224 else 315 else
225 if which md5sum >/dev/null 2>&1; then 316 if which md5sum >/dev/null 2>&1; then
226 cd ${S} 317 cd ${S}
227 ( 318 (
228 cd ${ROOT}${VDR_INCLUDE_DIR}/vdr 319 cd ${ROOT}${VDR_INCLUDE_DIR}
229 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 320 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
230 ) > header-md5-${PN} 321 ) > header-md5-${PN}
231 doins header-md5-${PN} 322 doins header-md5-${PN}
232 fi 323 fi
233 fi 324 fi

Legend:
Removed from v.1.21  
changed lines
  Added in v.1.34

  ViewVC Help
Powered by ViewVC 1.1.20